<template>
  <div class="result-container">
    <div v-if="items.length > 0">
      <div v-for="(item, i) in items" :key="item.item" class="d-flex mb-3">
        <span class="numbering align-self-start pe-2">
          <span class="text-underline">{{ hitCounter + i }}.</span>
        </span>

        <div class="d-flex flex-row">
          <a :href="getItemUrl(item)" class="text-decoration-none">
            <span class="mb-2">
              <span class="font-weight-regular">Sheet {{ item.n }}</span><span class="font-weight-light"> in </span><span class="font-weight-regular">{{ item.label }}</span>
            </span>

            <div class="d-flex multiple-hits hint">
              <span v-for="(matchItem, i) in item.matches" :key="i" class="d-flex">
                <small>{{ matchItem.occurrencesOnPage }} {{ matchItem.occurrencesOnPage === 1 ? 'hit' : 'hits' }} for <code>{{ matchItem.match }}</code></small>
              </span>
            </div>
            <small class="hint">{{ getLanguage(item.lang) }} Edition</small>
          </a>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      languagesMap: {
        ara: 'Arabic and Karshuni',
        karshuni: 'Arabic and Karshuni',
        syc: 'Syriac',
      },
    };
  },
  props: {
    hitCounter: {
      type: Number,
      default: () => 1,
    },
    items: {
      type: Array,
      default: () => [],
    },
    page: {
      type: Number,
      default: () => 1,
    },
  },
  methods: {
    getLanguage(code) {
      return this.languagesMap[code] || 'Unknown';
    },
    getItemUrl(item) {
      let language = '';

      if (item.lang === 'ara' || item.lang === 'karshuni') {
        language = 'arabic-karshuni';
      } else if (item.lang === 'syc') {
        language = 'syriac';
      }

      return `/${language}.html?language=&item=${item.item}`;
    },
  },
  watch: {
    page: function() {
      this.$emit('page-change', this.page);
    },
  },
};
</script>

<style lang="scss" scoped>
a {
  text-decoration: none;
}

.multiple-hits {
  flex-direction: column;
}

.hint {
  color: var(--c-text-lighter);
}

.numbering {
  width: 48px;
  text-align: right;
}

.result-container {
  min-height: 200px;
}
</style>
